/**
 * Style constants for all features.
 */
export default class StyleConstants {
    static readonly FULL_WIDTH: string = '100%';
    static readonly FULL_HEIGHT: string = '100%';
    static readonly TITLE_BAR_HEIGHT_PERCENT: string = '7.2%';
    static readonly WEIGHT_FULL: number = 1;
    static readonly CHAT_TOP_MARGIN_PERCENT: string = '3.1%';
    static readonly SET_CHAT_HEAD_SIZE_PERCENT: string = '8.9%';
    static readonly HEAD_ASPECT_RATIO: number = 1;
    static readonly HEAD_LEFT_PERCENT: string = '2.2%';
    static readonly HEAD_RIGHT_PERCENT: string = '6.7%';
    static readonly MAX_CHAT_WIDTH_PERCENT: string = '64.4%';
    static readonly UNIT_FP: string = 'fp';
    static readonly DOUBLE_ROW_MIN: number = 28;
    static readonly SLIDER_HORIZONTAL_MARGIN_PERCENT: string = '3.3%';
    static readonly SLIDER_TOP_MARGIN_PERCENT: string = '1%';
    static readonly BLOCK_WIDTH_PERCENT: string = '93.3%';
    static readonly A_WIDTH_PERCENT: string = '12.5%';
    static readonly SLIDER_WIDTH_PERCENT: string = '75%';
    static readonly SLIDER_LAYOUT_LEFT_PERCENT: string = '6.5%';
    static readonly SLIDER_LAYOUT_TOP_PERCENT: string = '3.2%';
    static readonly BLOCK_TOP_MARGIN_FIRST_PERCENT: string = '0.5%';
    static readonly BLOCK_TOP_MARGIN_SECOND_PERCENT: string = '1.5%';
}
