if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface ChatContent_Params {
    changeFontSize?: number;
    isLineFeed?: boolean;
    item?: ChatData;
}
interface ChatItemComponent_Params {
    item?: ChatData;
    changeFontSize?: number;
}
interface ChatListComponent_Params {
    contentArr?: ChatData[];
    changeFontSize?: number;
    tag?: string;
}
import StyleConstants from "@bundle:com.example.setappfontsize1/entry/ets/common/constants/StyleConstants";
import ChatData from "@bundle:com.example.setappfontsize1/entry/ets/viewmodel/ChatData";
import { ItemDirection } from "@bundle:com.example.setappfontsize1/entry/ets/viewmodel/ItemDirection";
export default class ChatListComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__contentArr = new SynchedPropertyObjectOneWayPU(params.contentArr, this, "contentArr");
        this.__changeFontSize = new SynchedPropertySimpleOneWayPU(params.changeFontSize, this, "changeFontSize");
        this.tag = '';
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: ChatListComponent_Params) {
        if (params.changeFontSize === undefined) {
            this.__changeFontSize.set(0);
        }
        if (params.tag !== undefined) {
            this.tag = params.tag;
        }
    }
    updateStateVars(params: ChatListComponent_Params) {
        this.__contentArr.reset(params.contentArr);
        this.__changeFontSize.reset(params.changeFontSize);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__contentArr.purgeDependencyOnElmtId(rmElmtId);
        this.__changeFontSize.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__contentArr.aboutToBeDeleted();
        this.__changeFontSize.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __contentArr: SynchedPropertySimpleOneWayPU<ChatData[]>;
    get contentArr() {
        return this.__contentArr.get();
    }
    set contentArr(newValue: ChatData[]) {
        this.__contentArr.set(newValue);
    }
    private __changeFontSize: SynchedPropertySimpleOneWayPU<number>;
    get changeFontSize() {
        return this.__changeFontSize.get();
    }
    set changeFontSize(newValue: number) {
        this.__changeFontSize.set(newValue);
    }
    private tag: string;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            List.create();
            List.layoutWeight(StyleConstants.WEIGHT_FULL);
        }, List);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            ForEach.create();
            const forEachItemGenFunction = _item => {
                const item = _item;
                {
                    const itemCreation = (elmtId, isInitialRender) => {
                        ViewStackProcessor.StartGetAccessRecordingFor(elmtId);
                        itemCreation2(elmtId, isInitialRender);
                        if (!isInitialRender) {
                            ListItem.pop();
                        }
                        ViewStackProcessor.StopGetAccessRecording();
                    };
                    const itemCreation2 = (elmtId, isInitialRender) => {
                        ListItem.create(deepRenderFunction, true);
                    };
                    const deepRenderFunction = (elmtId, isInitialRender) => {
                        itemCreation(elmtId, isInitialRender);
                        {
                            this.observeComponentCreation2((elmtId, isInitialRender) => {
                                if (isInitialRender) {
                                    let componentCall = new ChatItemComponent(this, { item, changeFontSize: this.changeFontSize }, undefined, elmtId, () => { }, { page: "entry/src/main/ets/view/ChatListComponent.ets", line: 16 });
                                    ViewPU.create(componentCall);
                                    let paramsLambda = () => {
                                        return {
                                            item,
                                            changeFontSize: this.changeFontSize
                                        };
                                    };
                                    componentCall.paramsGenerator_ = paramsLambda;
                                }
                                else {
                                    this.updateStateVarsOfChildByElmtId(elmtId, {
                                        item, changeFontSize: this.changeFontSize
                                    });
                                }
                            }, { name: "ChatItemComponent" });
                        }
                        ListItem.pop();
                    };
                    this.observeComponentCreation2(itemCreation2, ListItem);
                    ListItem.pop();
                }
            };
            this.forEachUpdateFunction(elmtId, this.contentArr, forEachItemGenFunction, (item: ChatData) => JSON.stringify(item), false, false);
        }, ForEach);
        ForEach.pop();
        List.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
class ChatItemComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__item = new SynchedPropertyObjectOneWayPU(params.item, this, "item");
        this.__changeFontSize = new SynchedPropertySimpleOneWayPU(params.changeFontSize, this, "changeFontSize");
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: ChatItemComponent_Params) {
        if (params.changeFontSize === undefined) {
            this.__changeFontSize.set(0);
        }
    }
    updateStateVars(params: ChatItemComponent_Params) {
        this.__item.reset(params.item);
        this.__changeFontSize.reset(params.changeFontSize);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__item.purgeDependencyOnElmtId(rmElmtId);
        this.__changeFontSize.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__item.aboutToBeDeleted();
        this.__changeFontSize.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __item: SynchedPropertySimpleOneWayPU<ChatData>;
    get item() {
        return this.__item.get();
    }
    set item(newValue: ChatData) {
        this.__item.set(newValue);
    }
    private __changeFontSize: SynchedPropertySimpleOneWayPU<number>;
    get changeFontSize() {
        return this.__changeFontSize.get();
    }
    set changeFontSize(newValue: number) {
        this.__changeFontSize.set(newValue);
    }
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.alignItems(VerticalAlign.Top);
            Row.width(StyleConstants.FULL_WIDTH);
            Row.direction(this.item.itemDirection === ItemDirection.RIGHT ? Direction.Rtl : Direction.Ltr);
            Row.margin({
                top: StyleConstants.CHAT_TOP_MARGIN_PERCENT
            });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Image.create(this.item.itemDirection === ItemDirection.LEFT ? { "id": 16777256, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" } : { "id": 16777257, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" });
            Image.width(StyleConstants.SET_CHAT_HEAD_SIZE_PERCENT);
            Image.aspectRatio(StyleConstants.HEAD_ASPECT_RATIO);
            Image.margin({
                left: this.item.itemDirection === ItemDirection.RIGHT
                    ? StyleConstants.HEAD_LEFT_PERCENT : StyleConstants.HEAD_RIGHT_PERCENT,
                right: this.item.itemDirection === ItemDirection.RIGHT
                    ? StyleConstants.HEAD_RIGHT_PERCENT : StyleConstants.HEAD_LEFT_PERCENT
            });
        }, Image);
        {
            this.observeComponentCreation2((elmtId, isInitialRender) => {
                if (isInitialRender) {
                    let componentCall = new ChatContent(this, { item: this.item, changeFontSize: this.changeFontSize }, undefined, elmtId, () => { }, { page: "entry/src/main/ets/view/ChatListComponent.ets", line: 41 });
                    ViewPU.create(componentCall);
                    let paramsLambda = () => {
                        return {
                            item: this.item,
                            changeFontSize: this.changeFontSize
                        };
                    };
                    componentCall.paramsGenerator_ = paramsLambda;
                }
                else {
                    this.updateStateVarsOfChildByElmtId(elmtId, {
                        changeFontSize: this.changeFontSize
                    });
                }
            }, { name: "ChatContent" });
        }
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
class ChatContent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.__changeFontSize = new SynchedPropertySimpleOneWayPU(params.changeFontSize, this, "changeFontSize");
        this.__isLineFeed = new SynchedPropertySimpleOneWayPU(params.isLineFeed, this, "isLineFeed");
        this.item = new ChatData();
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: ChatContent_Params) {
        if (params.changeFontSize === undefined) {
            this.__changeFontSize.set(0);
        }
        if (params.isLineFeed === undefined) {
            this.__isLineFeed.set(false);
        }
        if (params.item !== undefined) {
            this.item = params.item;
        }
    }
    updateStateVars(params: ChatContent_Params) {
        this.__changeFontSize.reset(params.changeFontSize);
        this.__isLineFeed.reset(params.isLineFeed);
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
        this.__changeFontSize.purgeDependencyOnElmtId(rmElmtId);
        this.__isLineFeed.purgeDependencyOnElmtId(rmElmtId);
    }
    aboutToBeDeleted() {
        this.__changeFontSize.aboutToBeDeleted();
        this.__isLineFeed.aboutToBeDeleted();
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private __changeFontSize: SynchedPropertySimpleOneWayPU<number>;
    get changeFontSize() {
        return this.__changeFontSize.get();
    }
    set changeFontSize(newValue: number) {
        this.__changeFontSize.set(newValue);
    }
    private __isLineFeed: SynchedPropertySimpleOneWayPU<boolean>;
    get isLineFeed() {
        return this.__isLineFeed.get();
    }
    set isLineFeed(newValue: boolean) {
        this.__isLineFeed.set(newValue);
    }
    private item: ChatData;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.constraintSize({ maxWidth: StyleConstants.MAX_CHAT_WIDTH_PERCENT });
            Row.direction(Direction.Ltr);
            Row.padding({
                left: { "id": 16777265, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                right: { "id": 16777265, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                top: { "id": 16777264, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                bottom: { "id": 16777264, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" }
            });
            Row.backgroundColor(this.item.itemDirection === ItemDirection.RIGHT
                ? { "id": 16777281, "type": 10001, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" } : { "id": 16777280, "type": 10001, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" });
            Row.borderRadius({ "id": 16777263, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.item.content);
            Text.fontColor({ "id": 16777283, "type": 10001, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" });
            Text.fontSize(this.changeFontSize + StyleConstants.UNIT_FP);
            Text.fontWeight(FontWeight.Medium);
            Text.onAreaChange((oldValue: Area, newValue: Area) => {
                this.isLineFeed = newValue.height > StyleConstants.DOUBLE_ROW_MIN;
            });
        }, Text);
        Text.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            If.create();
            if (this.isLineFeed) {
                this.ifElseBranchUpdateFunction(0, () => {
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        Blank.create();
                        Blank.layoutWeight(StyleConstants.WEIGHT_FULL);
                    }, Blank);
                    Blank.pop();
                });
            }
            else {
                this.ifElseBranchUpdateFunction(1, () => {
                });
            }
        }, If);
        If.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
