if (!("finalizeConstruction" in ViewPU.prototype)) {
    Reflect.set(ViewPU.prototype, "finalizeConstruction", () => { });
}
interface TitleBarComponent_Params {
    isBack?: boolean;
    title?: Resource;
}
import StyleConstants from "@bundle:com.example.setappfontsize1/entry/ets/common/constants/StyleConstants";
import router from "@ohos:router";
export default class TitleBarComponent extends ViewPU {
    constructor(parent, params, __localStorage, elmtId = -1, paramsLambda = undefined, extraInfo) {
        super(parent, __localStorage, elmtId, extraInfo);
        if (typeof paramsLambda === "function") {
            this.paramsGenerator_ = paramsLambda;
        }
        this.isBack = true;
        this.title = { "id": 16777235, "type": 10003, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" };
        this.setInitiallyProvidedValue(params);
        this.finalizeConstruction();
    }
    setInitiallyProvidedValue(params: TitleBarComponent_Params) {
        if (params.isBack !== undefined) {
            this.isBack = params.isBack;
        }
        if (params.title !== undefined) {
            this.title = params.title;
        }
    }
    updateStateVars(params: TitleBarComponent_Params) {
    }
    purgeVariableDependenciesOnElmtId(rmElmtId) {
    }
    aboutToBeDeleted() {
        SubscriberManager.Get().delete(this.id__());
        this.aboutToBeDeletedInternal();
    }
    private isBack: boolean;
    private title: Resource;
    initialRender() {
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Row.create();
            Row.width(StyleConstants.FULL_WIDTH);
            Row.height(StyleConstants.TITLE_BAR_HEIGHT_PERCENT);
            Row.padding({ left: { "id": 16777278, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" } });
        }, Row);
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            If.create();
            if (this.isBack) {
                this.ifElseBranchUpdateFunction(0, () => {
                    this.observeComponentCreation2((elmtId, isInitialRender) => {
                        Image.create({ "id": 16777251, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" });
                        Image.width({ "id": 16777277, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" });
                        Image.height({ "id": 16777277, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" });
                        Image.margin({ right: { "id": 16777276, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" } });
                        Image.onClick(() => {
                            router.back();
                        });
                    }, Image);
                });
            }
            else {
                this.ifElseBranchUpdateFunction(1, () => {
                });
            }
        }, If);
        If.pop();
        this.observeComponentCreation2((elmtId, isInitialRender) => {
            Text.create(this.title);
            Text.fontColor(Color.Black);
            Text.fontSize({ "id": 125829676, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" });
            Text.fontWeight(FontWeight.Medium);
            Text.margin({ left: { "id": 16777279, "type": 10002, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" } });
        }, Text);
        Text.pop();
        Row.pop();
    }
    rerender() {
        this.updateDirtyElements();
    }
}
