import SettingData from "@bundle:com.example.setappfontsize1/entry/ets/viewmodel/SettingData";
/**
 * Home view model, providing page display data.
 */
export class HomeViewModel {
    settingArr: SettingData[] = [];
    initSettingData(): SettingData[] {
        if (this.settingArr.length === 0) {
            let nameList = [
                { "id": 16777237, "type": 10003, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777242, "type": 10003, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777236, "type": 10003, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777240, "type": 10003, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777238, "type": 10003, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777239, "type": 10003, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" }
            ];
            let imageList = [
                { "id": 16777249, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777254, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777248, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777253, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777250, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" },
                { "id": 16777252, "type": 20000, params: [], "bundleName": "com.example.setappfontsize1", "moduleName": "entry" }
            ];
            nameList.map((name, index) => {
                let settingData = new SettingData();
                settingData.settingName = name;
                settingData.settingImage = imageList[index];
                this.settingArr.push(settingData);
            });
        }
        return this.settingArr;
    }
}
export default new HomeViewModel();
